package org.eclipse.birt.report.engine.script.internal;

import java.util.Date;

import org.eclipse.birt.core.format.DateFormatter;
import org.eclipse.birt.core.format.NumberFormatter;
import org.eclipse.birt.core.format.StringFormatter;
import org.eclipse.birt.report.engine.api.script.IFormatter;
import org.eclipse.birt.report.engine.executor.ExecutionContext;


public class FormatterImpl implements IFormatter
{
	
	protected ExecutionContext context;
	
	public  FormatterImpl(ExecutionContext context)
	{
		this.context = context;
	}

	public String format( Object value, String pattern )
	{
		if ( value != null )
		{
			if ( value instanceof Number )
			{
				NumberFormatter fmt = context.getNumberFormatter( pattern );
				return fmt.format( (Number) value );
			}
			else if ( value instanceof String )
			{
				StringFormatter fmt = context.getStringFormatter( pattern );
				return fmt.format( (String) value );

			}
			else if ( value instanceof Date )
			{
				DateFormatter fmt = context.getDateFormatter( pattern );
				return fmt.format( (Date) value );
			}
			else
			{
				return value.toString( );
			}
		}
		return "NULL";
	}

}
